/*---------------------------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/

#include "APP.h"
#include "AI8051U_GPIO.h"
#include "AI8051U_SPI.h"
#include "AI8051U_UART.h"
#include "AI8051U_NVIC.h"
#include "AI8051U_Switch.h"

/*************    ˵    **************

ͨڶSPI Flashждԡ

FLASHд롢Ĳַָ

(P3.0,P3.1)Ĭϲ:  115200,8,N,1.

: (ĸִСд)
    E 0x001234              --> ָʮƵַ.
    W 0x001234 1234567890   --> дָʮƵַΪд.
    R 0x001234 10           --> ָʮƵַΪֽ. 
    C                       --> ⲻSPI Flash, Cǿ.

ע⣺ΪͨãʶַǷЧûԼݾͺ

ʱ, ѡʱ 40MHz (ļ"config.h"޸).

******************************************/

//========================================================================
//                               س    
//========================================================================

sbit SPI_CE  = P4^0;     //PIN1
sbit SPI_SO  = P4^2;     //PIN2
sbit SPI_SI  = P4^1;     //PIN5
sbit SPI_SCK = P4^3;     //PIN6

#define EE_BUF_LENGTH   50

//========================================================================
//                               ر
//========================================================================

u32 Flash_addr;
u8  B_FlashOK;              //Flash״̬
u8  FLASH_ID, FLASH_ID1, FLASH_ID2;

//========================================================================
//                               غ
//========================================================================

void RX1_Check(void);
void SPI_Read_Nbytes( u32 addr, u8 *buffer, u16 size);
u8   SPI_Read_Compare(u32 addr, u8 *buffer, u16 size);
void SPI_Write_Nbytes(u32 addr, u8 *buffer,  u8 size);

//========================================================================
//                            ⲿͱ
//========================================================================


//========================================================================
// : SPI_PS_init
// : ûʼ.
// : None.
// : None.
// 汾: V1.0, 2020-09-27
//========================================================================
void SPI_Flash_init(void)
{
    SPI_InitTypeDef SPI_InitStructure;
    COMx_InitDefine COMx_InitStructure;     //ṹ

    COMx_InitStructure.UART_Mode      = UART_8bit_BRTx; //ģʽ, UART_ShiftRight,UART_8bit_BRTx,UART_9bit,UART_9bit_BRTx
    COMx_InitStructure.UART_BRT_Use   = BRT_Timer1;     //ѡʷ, BRT_Timer1, BRT_Timer2 (ע: 2̶ʹBRT_Timer2)
    COMx_InitStructure.UART_BaudRate  = 115200ul;       //, һ 110 ~ 115200
    COMx_InitStructure.UART_RxEnable  = ENABLE;         //,   ENABLEDISABLE
    COMx_InitStructure.TimeOutEnable  = ENABLE;         //ճʱʹ, ENABLE,DISABLE
    COMx_InitStructure.TimeOutINTEnable  = ENABLE;      //ʱжʹ, ENABLE,DISABLE
    COMx_InitStructure.TimeOutScale  = TO_SCALE_BRT;    //ʱʱԴѡ, TO_SCALE_BRT,TO_SCALE_SYSCLK
    COMx_InitStructure.TimeOutTimer  = 32ul;            //ʱʱ, 1 ~ 0xffffff
    UART_Configuration(UART1, &COMx_InitStructure);     //ʼ1 UART1,UART2,UART3,UART4
    NVIC_UART1_Init(ENABLE,Priority_1);     //жʹ, ENABLE/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3

    SPI_InitStructure.SPI_Enable    = ENABLE;           //SPI    ENABLE, DISABLE
    SPI_InitStructure.SPI_SSIG      = ENABLE;           //Ƭѡλ     ENABLE, DISABLE
    SPI_InitStructure.SPI_FirstBit  = SPI_MSB;          //λ   SPI_MSB, SPI_LSB
    SPI_InitStructure.SPI_Mode      = SPI_Mode_Master;  //ѡ   SPI_Mode_Master, SPI_Mode_Slave
    SPI_InitStructure.SPI_CPOL      = SPI_CPOL_High;    //ʱλ   SPI_CPOL_Low,    SPI_CPOL_High
    SPI_InitStructure.SPI_CPHA      = SPI_CPHA_2Edge;   //ݱ   SPI_CPHA_1Edge,  SPI_CPHA_2Edge
    SPI_InitStructure.SPI_Speed     = SPI_Speed_16;     //SPIٶ    SPI_Speed_4, SPI_Speed_8, SPI_Speed_16, SPI_Speed_2
    SPI_Init(&SPI_InitStructure);
    NVIC_SPI_Init(DISABLE,Priority_0);      //жʹ, ENABLE/DISABLE; ȼ(͵) Priority_0,Priority_1,Priority_2,Priority_3

    SPI_SW(SPI_P40_P41_P42_P43);            //SPI_P14_P15_P16_P17,SPI_P24_P25_P26_P27,SPI_P40_P41_P42_P43,SPI_P35_P34_P33_P32
    P3_MODE_IO_PU(GPIO_Pin_0 | GPIO_Pin_1); //P3.0,P3.1 Ϊ׼˫
    P4_MODE_IO_PU(GPIO_Pin_LOW);            //P40~P43 Ϊ׼˫
    P5_PULL_UP_ENABLE(GPIO_Pin_2 | GPIO_Pin_3); //P5.2,P5.3 ڲʹ

    SPI_SCK = 0;    // set clock to low initial state
    SPI_SI = 1;

    printf(":\r\n");
    printf("E 0x001234            -->   ʮƵַ\r\n");
    printf("W 0x001234 1234567890 --> д  ʮƵַ  д\r\n");
    printf("R 0x001234 10         -->   ʮƵַ  ֽ\r\n");
    printf("C                     --> ⲻSPI Flash, Cǿ.\r\n\r\n");

    FlashCheckID();
    FlashCheckID();
    
    if(!B_FlashOK)  printf("δ⵽PM25LV040/W25X40CL/W25Q80BV/W25Q128FV!\r\n");
    else
    {
        if(B_FlashOK == 1)
        {
            printf("⵽PM25LV040!\r\n");
        }
        else if(B_FlashOK == 2)
        {
            printf("⵽W25X40CL!\r\n");
        }
        else if(B_FlashOK == 3)
        {
            printf("⵽W25Q80BV!\r\n");
        }
        else if(B_FlashOK == 4)
        {
            printf("⵽W25Q128FV!\r\n");
        }
    }
    printf("ID1 = 0x%02X",FLASH_ID1);
    printf("\r\n      ID2 = 0x%02X",FLASH_ID2);
    printf("\r\n   豸ID = 0x%02X\r\n",FLASH_ID);
}

//========================================================================
// : Sample_SPI_PS
// : ûӦó.
// : None.
// : None.
// 汾: V1.0, 2020-09-27
//========================================================================
void Sample_SPI_Flash(void)
{
    if(COM1.RX_TimeOut)
    {
        COM1.RX_TimeOut = 0;

        if(COM1.RX_Cnt > 0)
        {
            RX1_Check();        //1
        }
        COM1.RX_Cnt = 0;
    }
}

/**************** ASCIIתBIN ****************************/
u8  CheckData(u8 dat)
{
    if((dat >= '0') && (dat <= '9')) return (dat-'0');
    if((dat >= 'A') && (dat <= 'F')) return (dat-'A'+10);
    return 0xff;
}

/**************** ȡдַ ****************************/
u32 GetAddress(void)
{
    u32 address;
    u8  i,j;
    
    address = 0;
    if((RX1_Buffer[2] == '0') && (RX1_Buffer[3] == 'X'))
    {
        for(i=4; i<10; i++)
        {
            j = CheckData(RX1_Buffer[i]);
            if(j >= 0x10)   return 0x80000000;  //error
            address = (address << 4) + j;
        }
        return (address);
    }
    return  0x80000000; //error
}

/**************** ȡҪݵֽ ****************************/
u8  GetDataLength(void)
{
    u8  i;
    u8  length;
    
    length = 0;
    for(i=11; i<COM1.RX_Cnt; i++)
    {
        if(CheckData(RX1_Buffer[i]) >= 10)  break;
        length = length * 10 + CheckData(RX1_Buffer[i]);
    }
    return (length);
}

/**************** ڴ ****************************/

void RX1_Check(void)
{
    u8  i,j;
    u8  temp[EE_BUF_LENGTH];

    if((COM1.RX_Cnt == 1) && (RX1_Buffer[0] == 'C'))    //Cǿ
    {
        B_FlashOK = 1;
        printf("ǿFLASH!\r\n");
    }

    if(!B_FlashOK)
    {
        printf("PM25LV040/W25X40CL/W25Q80BV/W25Q128FV, ܲFLASH!\r\n");
        return;
    }
    
    F0 = 0;
    if((COM1.RX_Cnt >= 10) && (RX1_Buffer[1] == ' '))   //Ϊ10ֽ
    {
        for(i=0; i<10; i++)
        {
            if((RX1_Buffer[i] >= 'a') && (RX1_Buffer[i] <= 'z'))    RX1_Buffer[i] = RX1_Buffer[i] - 'a' + 'A';//Сдתд
        }
        Flash_addr = GetAddress();
        if(Flash_addr < 0x80000000)
        {
            if(RX1_Buffer[0] == 'E')    //
            {
                FlashSectorErase(Flash_addr);
                printf("Ѳǰ!\r\n");
                F0 = 1;
            }

            else if((RX1_Buffer[0] == 'W') && (COM1.RX_Cnt >= 12) && (RX1_Buffer[10] == ' '))   //дNֽ
            {
                j = COM1.RX_Cnt - 11;
                for(i=0; i<j; i++)  temp[i] = 0xff;      //ҪдĿռǷΪ
                i = SPI_Read_Compare(Flash_addr,temp,j);
                if(i > 0)
                {
                    printf("ҪдĵַΪǿ,д,Ȳ!\r\n");
                }
                else
                {
                    SPI_Write_Nbytes(Flash_addr,&RX1_Buffer[11],j);     //дNֽ 
                    i = SPI_Read_Compare(Flash_addr,&RX1_Buffer[11],j); //Ƚд
                    if(i == 0)
                         printf("д%uֽ!\r\n",j);
                    else printf("д!\r\n");
                }
                F0 = 1;
            }
            else if((RX1_Buffer[0] == 'R') && (COM1.RX_Cnt >= 12) && (RX1_Buffer[10] == ' '))   //Nֽ
            {
                j = GetDataLength();
                if((j > 0) && (j < EE_BUF_LENGTH))
                {
                    SPI_Read_Nbytes(Flash_addr,temp,j);
                    printf("%uֽ£\r\n",j);
                    for(i=0; i<j; i++)  printf("%c",temp[i]);
                    printf("\r\n");
                    F0 = 1;
                }
            }
        }
    }
    if(!F0) printf("!\r\n");
}

void FlashCheckID(void)
{
    SPI_CE  = 0;
    SPI_WriteByte(SFC_RDID);        //ͶȡID
    SPI_WriteByte(0x00);            //ն3ֽ
    SPI_WriteByte(0x00);
    SPI_WriteByte(0x00);
    FLASH_ID1 = SPI_ReadByte();     //ȡID1
    FLASH_ID  = SPI_ReadByte();     //ȡ豸ID
    FLASH_ID2 = SPI_ReadByte();     //ȡID2
    SPI_CE  = 1;

//    printf("ID1=0x%02x,ID=0x%02x,ID2=0x%02x\r\n",FLASH_ID1,FLASH_ID,FLASH_ID2);

    if((FLASH_ID1 == 0x9d) && (FLASH_ID2 == 0x7f))  B_FlashOK = 1;  //ǷΪPM25LVxxϵеFlash
    else if(FLASH_ID == 0x12)  B_FlashOK = 2;                       //ǷΪW25X4xϵеFlash
    else if(FLASH_ID == 0x13)  B_FlashOK = 3;                       //ǷΪW25X8xϵеFlash
    else if(FLASH_ID == 0x17)  B_FlashOK = 4;                       //ǷΪW25X128ϵеFlash
    else                                            B_FlashOK = 0;
}

/************************************************
Flashæ״̬
ڲ: 
ڲ:
    0 : Flashڿ״̬
    1 : Flashæ״̬
************************************************/
u8 CheckFlashBusy(void)
{
    u8  dat;

    SPI_CE  = 0;
    SPI_WriteByte(SFC_RDSR);        //Ͷȡ״̬
    dat = SPI_ReadByte();           //ȡ״̬
    SPI_CE  = 1;

    return (dat);                   //״ֵ̬Bit0Ϊæ־
}

/************************************************
ʹFlashд
ڲ: 
ڲ: 
************************************************/
void FlashWriteEnable(void)
{
    while(CheckFlashBusy() > 0);    //Flashæ
    SPI_CE  = 0;
    SPI_WriteByte(SFC_WREN);        //дʹ
    SPI_CE  = 1;
}

/************************************************
ƬFlash
ڲ: 
ڲ: 
************************************************/
/*
void FlashChipErase(void)
{
    if(B_FlashOK)
    {
        FlashWriteEnable();         //ʹFlashд
        SPI_CE  = 0;
        SPI_WriteByte(SFC_CHIPER);  //Ƭ
        SPI_CE  = 1;
    }
}
*/

/************************************************
, һ4KB
ڲ: 
ڲ: 
************************************************/
void FlashSectorErase(u32 addr)
{
    if(B_FlashOK)
    {
        FlashWriteEnable();     //ʹFlashд
        SPI_CE  = 0;
        if(B_FlashOK == 1)
        {
            SPI_WriteByte(SFC_SECTORER1);   //
        }
        else
        {
            SPI_WriteByte(SFC_SECTORER2);   //
        }
        SPI_WriteByte(((u8 *)&addr)[1]);    //ʼַ
        SPI_WriteByte(((u8 *)&addr)[2]);
        SPI_WriteByte(((u8 *)&addr)[3]);
        SPI_CE  = 1;
    }
}

/************************************************
Flashжȡ
ڲ:
    addr   : ַ
    buffer : Flashжȡ
    size   : ݿС
ڲ:
    
************************************************/
void SPI_Read_Nbytes(u32 addr, u8 *buffer, u16 size)
{
    if(size == 0)   return;
    if(!B_FlashOK)  return;
    while(CheckFlashBusy() > 0);        //Flashæ

    SPI_CE  = 0;                        //enable device
    SPI_WriteByte(SFC_READ);            //read command

    SPI_WriteByte(((u8 *)&addr)[1]);    //ʼַ
    SPI_WriteByte(((u8 *)&addr)[2]);
    SPI_WriteByte(((u8 *)&addr)[3]);

    do{
        *buffer = SPI_ReadByte();       //receive byte and store at buffer
        buffer++;
    }while(--size);                     //read until no_bytes is reached
    SPI_CE  = 1;                        //disable device
}

/************************************************************************
nֽ,ָݽбȽ, 󷵻1,ȷ0
************************************************************************/
u8 SPI_Read_Compare(u32 addr, u8 *buffer, u16 size)
{
    u8  j;
    if(size == 0)   return 2;
    if(!B_FlashOK)  return 2;
    while(CheckFlashBusy() > 0);        //Flashæ

    j = 0;
    SPI_CE  = 0;                        //enable device
    SPI_WriteByte(SFC_READ);            //read command
    SPI_WriteByte(((u8 *)&addr)[1]);    //ʼַ
    SPI_WriteByte(((u8 *)&addr)[2]);
    SPI_WriteByte(((u8 *)&addr)[3]);
    do
    {
        if(*buffer != SPI_ReadByte())   //receive byte and store at buffer
        {
            j = 1;
            break;
        }
        buffer++;
    }while(--size);     //read until no_bytes is reached
    SPI_CE  = 1;        //disable device
    return j;
}

/************************************************
дݵFlash
ڲ:
    addr   : ַ
    buffer : ҪдFlash
    size   : ݿС
ڲ: 
************************************************/
void SPI_Write_Nbytes(u32 addr, u8 *buffer, u8 size)
{
    if(size == 0)   return;
    if(!B_FlashOK)  return;
    while(CheckFlashBusy() > 0);        //Flashæ

    FlashWriteEnable();                 //ʹFlashд

    SPI_CE  = 0;                        // enable device
    SPI_WriteByte(SFC_PAGEPROG);        // ҳ
    SPI_WriteByte(((u8 *)&addr)[1]);    //ʼַ
    SPI_WriteByte(((u8 *)&addr)[2]);
    SPI_WriteByte(((u8 *)&addr)[3]);
    do{
        SPI_WriteByte(*buffer++);       //ҳд
        addr++;
        if ((addr & 0xff) == 0) break;
    }while(--size);
    SPI_CE  = 1;                        // disable device
}
