/*---------------------------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/

#ifndef	__AI8051U_LCM_H
#define	__AI8051U_LCM_H

#include "config.h"

//========================================================================
//                              λ
//========================================================================

sbit LCD_RS = P4^5;         ///л
sbit LCD_WR = P3^6;         //д
sbit LCD_RD = P3^7;         //
sbit LCD_CS = P0^5;         //Ƭѡ
sbit LCD_RESET = P4^7;      //λ

//========================================================================
//                              
//========================================================================

#define LCM_WRITE_CMD()			LCMIFCR = ((LCMIFCR & ~0x07) | 0x84)
#define LCM_WRITE_DAT()			LCMIFCR = ((LCMIFCR & ~0x07) | 0x85)
#define LCM_READ_CMD()			LCMIFCR = ((LCMIFCR & ~0x07) | 0x86)
#define LCM_READ_DAT()			LCMIFCR = ((LCMIFCR & ~0x07) | 0x87)

#define SET_LCM_DAT_LOW(n)		LCMIFDATL = (n)
#define SET_LCM_DAT_HIGH(n)		LCMIFDATH = (n)

//========================================================================
//                              
//========================================================================

#define	MODE_I8080			0	//I8080ģʽ
#define	MODE_M6800			1	//M6800ģʽ

#define	BIT_WIDE_8			0	//8λݿ
#define	BIT_WIDE_16			2	//16λݿ

//========================================================================
//                              
//========================================================================

typedef struct
{
	u8	LCM_Enable;					//LCMӿʹ  	ENABLE,DISABLE
	u8	LCM_Mode;						//LCMӿģʽ  	MODE_I8080,MODE_M6800
	u8	LCM_Bit_Wide;				//LCMݿ  	BIT_WIDE_8,BIT_WIDE_16
	u8	LCM_Setup_Time;			//LCMͨݽʱ  	0~7
	u8	LCM_Hold_Time;			//LCMͨݱʱ  	0~3
} LCM_InitTypeDef;


//========================================================================
//                              ⲿ
//========================================================================
extern bit LcmFlag;

void LCM_Inilize(LCM_InitTypeDef *LCM);

#endif
