/*---------------------------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/

#include "AI8051U_QSPI.h"

//========================================================================
// : u8 QSPI_Inilize(ADC_InitTypeDef *ADCx)
// : ADCʼ.
// : ADCx: ṹ,οadc.hĶ.
// : none.
// 汾: V1.0, 2012-10-22
//========================================================================
u8 QSPI_Inilize(QSPI_InitTypeDef *QSPI)
{
    if(QSPI->FIFOLevel > 31)    return FAIL;    //
    if(QSPI->FlashSize > 31)    return FAIL;    //
    if(QSPI->CSHold > 7)        return FAIL;    //

    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetFIFOLevel(QSPI->FIFOLevel);         //FIFOֵΪ(31+1)=32ֽ
    QSPI_SetClockDivider(QSPI->ClockDiv);       //QSPIʱΪϵͳʱ/(4+1)
    QSPI_SetCSHold(QSPI->CSHold);               //CSʱΪ(1+1)=2QSPIʱ

    if(QSPI->CKMode)    QSPI_SetIdleCLKHigh();  //ʱSCKΪߵƽ
    else    QSPI_SetIdleCLKLow();               //ʱSCKΪ͵ƽ

    QSPI_SetFlashSize(QSPI->FlashSize);         //FlashСΪ2^(25+1)=64Mֽ,

    if(QSPI->SIOO)    QSPI_InstructionOnce();   //ýһָ
    else    QSPI_InstructionAlways();           //ÿָ

    if(QSPI->QSPI_EN)    QSPI_Enable();         //ʹQSPI
    else    QSPI_Disable();                     //ֹQSPI

    return SUCCESS;
}

void QSPI_WRITE_INSTR(BYTE cmd)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_NoAddress();               //޵ַֽ
  	QSPI_NoAlternate();             //޼ֽ
    QSPI_NoData();                  //
    QSPI_SetInstruction(cmd);       //ָ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_READ_INSTR_SDATA(BYTE cmd, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_NoAddress();               //޵ַֽ
  	QSPI_NoAlternate();             //޼ֽ
    QSPI_DataSingMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_WRITE_INSTR_SADDR8(BYTE cmd, BYTE addr)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetAddressSize(0);         //õַΪ8λ(0+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_NoData();                  //
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_WRITE_INSTR_SADDR16(BYTE cmd, WORD addr)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetAddressSize(1);         //õַΪ16λ(1+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_NoData();                  //
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_WRITE_INSTR_SADDR24(BYTE cmd, DWORD addr)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_NoData();                  //
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_WRITE_INSTR_SADDR32(BYTE cmd, DWORD addr)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_NoData();                  //
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_WRITE_INSTR_QADDR32(BYTE cmd, DWORD addr)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressQuadMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_NoData();                  //
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_READ_INSTR_SADDR24_SDATA(BYTE cmd, DWORD addr, BYTE *pdat, WORD datalen)
{
    QSPI_READ_INSTR_SADDR24_DUMMY_SDATA(cmd, addr, 0, pdat, datalen);
}

void QSPI_READ_INSTR_SADDR24_DUMMY_SDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataSingMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_DMA_READ_INSTR_SADDR24_SDATA(BYTE cmd, DWORD addr, BYTE *pdat, WORD datalen)
{
    QSPI_DMA_READ_INSTR_SADDR24_DUMMY_SDATA(cmd, addr, 0, pdat, datalen);
}

void QSPI_DMA_READ_INSTR_SADDR24_DUMMY_SDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataSingMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    
    QSPI_DMA_READ(pdat, datalen);
}

void QSPI_READ_INSTR_SADDR32_SDATA(BYTE cmd, DWORD addr, BYTE *pdat, WORD datalen)
{
    QSPI_READ_INSTR_SADDR32_DUMMY_SDATA(cmd, addr, 0, pdat, datalen);
}

void QSPI_READ_INSTR_SADDR32_DUMMY_SDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataSingMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_DMA_READ_INSTR_SADDR32_SDATA(BYTE cmd, DWORD addr, BYTE *pdat, WORD datalen)
{
    QSPI_DMA_READ_INSTR_SADDR32_DUMMY_SDATA(cmd, addr, 0, pdat, datalen);
}

void QSPI_DMA_READ_INSTR_SADDR32_DUMMY_SDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataSingMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ

    QSPI_DMA_READ(pdat, datalen);
}

void QSPI_READ_INSTR_DADDR24_DALT8_DDATA(BYTE cmd, DWORD addr, BYTE alt, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetAlternateSize(0);       //üֽڿΪ8λ(0+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressDualMode();         //õַΪ˫ģʽ
    QSPI_AlternateDualMode();       //üֽΪ˫ģʽ
    QSPI_DataDualMode();            //Ϊ˫ģʽ
    QSPI_SetAlternate(alt);         //üֽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_DMA_READ_INSTR_DADDR24_DALT8_DDATA(BYTE cmd, DWORD addr, BYTE alt, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetAlternateSize(0);       //üֽڿΪ8λ(0+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_AlternateDualMode();       //üֽΪ˫ģʽ
    QSPI_DataDualMode();            //Ϊ˫ģʽ
    QSPI_SetAlternate(alt);         //üֽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressDualMode();         //õַΪ˫ģʽ

    QSPI_DMA_READ(pdat, datalen);
}

void QSPI_READ_INSTR_DADDR32_DALT8_DDATA(BYTE cmd, DWORD addr, BYTE alt, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetAlternateSize(0);       //üֽڿΪ8λ(0+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressDualMode();         //õַΪ˫ģʽ
    QSPI_AlternateDualMode();       //üֽΪ˫ģʽ
    QSPI_DataDualMode();            //Ϊ˫ģʽ
    QSPI_SetAlternate(alt);         //üֽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_DMA_READ_INSTR_DADDR32_DALT8_DDATA(BYTE cmd, DWORD addr, BYTE alt, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetAlternateSize(0);       //üֽڿΪ8λ(0+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_AlternateDualMode();       //üֽΪ˫ģʽ
    QSPI_DataDualMode();            //Ϊ˫ģʽ
    QSPI_SetAlternate(alt);         //üֽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressDualMode();         //õַΪ˫ģʽ

    QSPI_DMA_READ(pdat, datalen);
}

void QSPI_READ_INSTR_SADDR24_DUMMY_DDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataDualMode();            //Ϊ˫ģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_DMA_READ_INSTR_SADDR24_DUMMY_DDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataDualMode();            //Ϊ˫ģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ

    QSPI_DMA_READ(pdat, datalen);
}

void QSPI_READ_INSTR_SADDR24_DUMMY_QDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_DMA_READ_INSTR_SADDR24_DUMMY_QDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ

    QSPI_DMA_READ(pdat, datalen);
}

void QSPI_READ_INSTR_SADDR32_DUMMY_DDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataDualMode();            //Ϊ˫ģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_DMA_READ_INSTR_SADDR32_DUMMY_DDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataDualMode();            //Ϊ˫ģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ

    QSPI_DMA_READ(pdat, datalen);
}

void QSPI_READ_INSTR_SADDR32_DUMMY_QDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_DMA_READ_INSTR_SADDR32_DUMMY_QDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ

    QSPI_DMA_READ(pdat, datalen);
}

void QSPI_READ_INSTR_QADDR24_QALT8_DUMMY_QDATA(BYTE cmd, DWORD addr, BYTE alt, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetAlternateSize(0);       //üֽڿΪ8λ(0+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressQuadMode();         //õַΪģʽ
    QSPI_AlternateQuadMode();       //üֽΪģʽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetAlternate(alt);         //üֽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_DMA_READ_INSTR_QADDR24_QALT8_DUMMY_QDATA(BYTE cmd, DWORD addr, BYTE alt, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetAlternateSize(0);       //üֽڿΪ8λ(0+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_AlternateQuadMode();       //üֽΪģʽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetAlternate(alt);         //üֽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressQuadMode();         //õַΪģʽ

    QSPI_DMA_READ(pdat, datalen);
}

void QSPI_READ_INSTR_QADDR32_QALT8_DUMMY_QDATA(BYTE cmd, DWORD addr, BYTE alt, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetAlternateSize(0);       //üֽڿΪ8λ(0+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressQuadMode();         //õַΪģʽ
    QSPI_AlternateQuadMode();       //üֽΪģʽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetAlternate(alt);         //üֽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_DMA_READ_INSTR_QADDR32_QALT8_DUMMY_QDATA(BYTE cmd, DWORD addr, BYTE alt, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetAlternateSize(0);       //üֽڿΪ8λ(0+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_AlternateQuadMode();       //üֽΪģʽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetAlternate(alt);         //üֽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressQuadMode();         //õַΪģʽ

    QSPI_DMA_READ(pdat, datalen);
}

void QSPI_WRITE_INSTR_SADDR24_SDATA(BYTE cmd, DWORD addr, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataSingMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    while (datalen)
    {
        QSPI_WriteData(*pdat);      //дݵFIFO
        pdat++;
        datalen--;
    }

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_DMA_WRITE_INSTR_SADDR24_SDATA(BYTE cmd, DWORD addr, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataSingMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    
    QSPI_DMA_WRITE(pdat, datalen);
}

void QSPI_WRITE_INSTR_SADDR24_QDATA(BYTE cmd, DWORD addr, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (datalen)
    {
        QSPI_WriteData(*pdat);      //дݵFIFO
        pdat++;
        datalen--;
    }
    
    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_DMA_WRITE_INSTR_SADDR24_QDATA(BYTE cmd, DWORD addr, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    
    QSPI_DMA_WRITE(pdat, datalen);
}

void QSPI_WRITE_INSTR_SADDR32_SDATA(BYTE cmd, DWORD addr, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataSingMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    while (datalen)
    {
        QSPI_WriteData(*pdat);      //дݵFIFO
        pdat++;
        datalen--;
    }

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_DMA_WRITE_INSTR_SADDR32_SDATA(BYTE cmd, DWORD addr, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataSingMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    
    QSPI_DMA_WRITE(pdat, datalen);
}

void QSPI_WRITE_INSTR_SADDR32_QDATA(BYTE cmd, DWORD addr, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    while (datalen)
    {
        QSPI_WriteData(*pdat);      //дݵFIFO
        pdat++;
        datalen--;
    }

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_DMA_WRITE_INSTR_SADDR32_QDATA(BYTE cmd, DWORD addr, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(3);         //õַΪ32λ(3+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_AddressSingMode();         //õַΪģʽ
    
    QSPI_DMA_WRITE(pdat, datalen);
}

void QSPI_WRITE_QINSTR(BYTE cmd)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionQuadMode();     //ָΪģʽ
    QSPI_NoAddress();               //޵ַֽ
  	QSPI_NoAlternate();             //޼ֽ
    QSPI_NoData();                  //
    QSPI_SetInstruction(cmd);       //ָ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_READ_QINSTR_QDATA(BYTE cmd, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionQuadMode();     //ָΪģʽ
    QSPI_NoAddress();               //޵ַֽ
  	QSPI_NoAlternate();             //޼ֽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_WRITE_QINSTR_QADDR8(BYTE cmd, BYTE addr)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetAddressSize(0);         //õַΪ8λ(0+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionQuadMode();     //ָΪģʽ
    QSPI_AddressQuadMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_NoData();                  //
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_READ_QINSTR_QADDR24_DUMMY_QDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_InstructionQuadMode();     //ָΪģʽ
    QSPI_AddressQuadMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_DMA_READ_QINSTR_QADDR24_DUMMY_QDATA(BYTE cmd, DWORD addr, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_NoAlternate();             //޼ֽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionQuadMode();     //ָΪģʽ
    QSPI_AddressQuadMode();         //õַΪģʽ

    QSPI_DMA_READ(pdat, datalen);
}

void QSPI_READ_QINSTR_QADDR24_QALT8_DUMMY_QDATA(BYTE cmd, DWORD addr, BYTE alt, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetAlternateSize(0);       //üֽڿΪ8λ(0+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_InstructionQuadMode();     //ָΪģʽ
    QSPI_AddressQuadMode();         //õַΪģʽ
    QSPI_AlternateQuadMode();       //üֽΪģʽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetAlternate(alt);         //üֽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־

    while (datalen)
    {
        *pdat = QSPI_ReadData();    //FIFOжȡ
        pdat++;
        datalen--;
    }
    
    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_DMA_READ_QINSTR_QADDR24_QALT8_DUMMY_QDATA(BYTE cmd, DWORD addr, BYTE alt, BYTE dcyc, BYTE *pdat, WORD datalen)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetDataLength(datalen-1);  //ݳ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetAlternateSize(0);       //üֽڿΪ8λ(0+1ֽ)
    QSPI_SetDummyCycles(dcyc);      //DUMMYʱ
    QSPI_NoInstruction();           //ָģʽ(ֹ󴥷)
    QSPI_NoAddress();               //޵ַģʽ(ֹ󴥷)
    QSPI_AlternateQuadMode();       //üֽΪģʽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetAlternate(alt);         //üֽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ
    QSPI_InstructionQuadMode();     //ָΪģʽ
    QSPI_AddressQuadMode();         //õַΪģʽ

    QSPI_DMA_READ(pdat, datalen);
}

void QSPI_WRITE_QINSTR_QADDR24(BYTE cmd, DWORD addr)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetWriteMode();            //дģʽ
    QSPI_SetAddressSize(2);         //õַΪ24λ(2+1ֽ)
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionQuadMode();     //ָΪģʽ
    QSPI_AddressQuadMode();         //õַΪģʽ
    QSPI_NoAlternate();             //޼ֽ
    QSPI_NoData();                  //
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetAddress(addr);          //õַ

    while (!QSPI_CheckTransfer());  //ȵݴ
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_READ_QINSTR_QADDR24_QDATA(BYTE cmd, DWORD addr, BYTE *pdat, WORD datalen)
{
    QSPI_READ_QINSTR_QADDR24_DUMMY_QDATA(cmd, addr, 0, pdat, datalen);
}

void QSPI_POLLING_READ_INSTR_SDATA(BYTE cmd, BYTE mask, BYTE match, WORD clks)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetPollingMask(mask);      //ѯ״̬λ
    QSPI_SetPollingMatch(match);    //ѯ״̬ƥλ
    QSPI_SetPollingInterval(clks);  //ѯ
    QSPI_PollingMatchAND();         //ѯƥģʽ
    QSPI_PollingAutoStop();         //ѯƥʱԶֹͣѯ
    QSPI_SetDataLength(0);          //ݳ
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionSingMode();     //ָΪģʽ
    QSPI_NoAddress();               //޵ַֽ
  	QSPI_NoAlternate();             //޼ֽ
    QSPI_DataSingMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetPollingMode();          //ѯģʽ

    while (!QSPI_CheckMatch());     //ȵѯ
    QSPI_ClearMatch();              //ѯɱ־

    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_POLLING_READ_QINSTR_QDATA(BYTE cmd, BYTE mask, BYTE match, WORD clks)
{
    while (QSPI_CheckBusy());       //æ״̬

    QSPI_SetReadMode();             //ģʽ
    QSPI_SetPollingMask(mask);      //ѯ״̬λ
    QSPI_SetPollingMatch(match);    //ѯ״̬ƥλ
    QSPI_SetPollingInterval(clks);  //ѯ
    QSPI_PollingMatchAND();         //ѯƥģʽ
    QSPI_PollingAutoStop();         //ѯƥʱԶֹͣѯ
    QSPI_SetDataLength(0);          //ݳ
    QSPI_SetDummyCycles(0);         //DUMMYʱ
    QSPI_InstructionQuadMode();     //ָΪģʽ
    QSPI_NoAddress();               //޵ַֽ
  	QSPI_NoAlternate();             //޼ֽ
    QSPI_DataQuadMode();            //Ϊģʽ
    QSPI_SetInstruction(cmd);       //ָ
    QSPI_SetPollingMode();          //ѯģʽ

    while (!QSPI_CheckMatch());     //ȵѯ
    QSPI_ClearMatch();              //ѯɱ־

    while (QSPI_CheckFIFOLevel())   //FIFO
        QSPI_ReadData();
}

void QSPI_DMA_READ(BYTE *pdat, WORD datalen)
{
    DMA_QSPI_AMT = datalen-1;       //DMAݳ
    DMA_QSPI_AMTH = (datalen-1) >> 8;
    DMA_QSPI_RXAH = (WORD)pdat >> 8;//DMAĴ洢ʼַ
    DMA_QSPI_RXAL = (BYTE)pdat;     //DMAĴ洢ʼַ
    DMA_QSPI_STA = 0x00;            //DMA״̬
    DMA_QSPI_CFG = 0x20;            //ʹDMAȡ
    DMA_QSPI_CR = 0xa1;             //DMAQSPI
    while (!(DMA_QSPI_STA & 0x01)); //ȴDMA
    DMA_QSPI_STA = 0x00;            //DMA״̬
    DMA_QSPI_CFG = 0x00;
    DMA_QSPI_CR = 0x00;
    QSPI_ClearTransfer();           //ɱ־
}

void QSPI_DMA_WRITE(BYTE *pdat, WORD datalen)
{
    DMA_QSPI_AMT = datalen-1;       //DMAݳ
    DMA_QSPI_AMTH = (datalen-1) >> 8;
    DMA_QSPI_TXAH = (WORD)pdat >> 8;//DMAĴ洢ʼַ
    DMA_QSPI_TXAL = (BYTE)pdat;     //DMAĴ洢ʼַ
    DMA_QSPI_STA = 0x00;            //DMA״̬
    DMA_QSPI_CFG = 0x40;            //ʹDMAд
    DMA_QSPI_CR = 0xc2;             //DMAQSPIд
    while (!(DMA_QSPI_STA & 0x01)); //ȴDMA
    DMA_QSPI_STA = 0x00;            //DMA״̬
    DMA_QSPI_CFG = 0x00;
    DMA_QSPI_CR = 0x00;
    QSPI_ClearTransfer();           //ɱ־
}
